<template>
  <div class="relative w-full group h-game-entry flex" :variant="variant">
    <!-- Background -->
    <div class="w-full h-full">
      <img src="@/public/bg1-1.png" class="rounded-lg w-full h-full" />
    </div>
    <!-- Content -->
    <div class="absolute top-0 left-0 flex w-full h-full">
      <div class="flex flex-col w-full h-full items-center justify-center">
        <img
          v-if="
            (!floatBgImage || floatBgImage.length <= 0) &&
            personImage &&
            personImage.length > 0
          "
          :src="personImage"
          loading="lazy"
          class="object-contain self-end h-[280px] w[280px]"
          @error="
            (e) =>
              isHandleDefaultImageRender(personImage, $route.name === 'index')
                ? onErrorDefaultImage(e, personImage, $route.name === 'index')
                : e.target.remove()
          "
        />
        <div
          v-if="floatBgImage && floatBgImage.length > 0"
          class="relative flex items-center justify-center w-full h-full"
        >
          <template v-if="isFloatBackgroundEntry">
            <img
              v-if="floatBgImage && floatBgImage.length > 0"
              :src="floatBgImage"
              loading="lazy"
              class="self-center object-contain w-11/12 h-full justify-self-end"
              @error="
                (e) =>
                  isHandleDefaultImageRender(floatBgImage)
                    ? onErrorDefaultImage(e, floatBgImage)
                    : e.target.remove()
              "
            />
          </template>
          <img
            v-if="personImage && personImage.length > 0"
            :src="personImage"
            loading="lazy"
            class="justify-self-end self-end object-contain absolute bottom-0 right-[6%] mt-auto h-[280px] w-[280px]"
            @error="
              (e) =>
                isHandleDefaultImageRender(personImage)
                  ? onErrorDefaultImage(e, personImage)
                  : e.target.remove()
            "
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { PropType, ref, defineProps } from "vue";
import commonHelper from "@/utils/commonHelper";

defineProps({
  bgImage: {
    type: String,
    required: false,
  },
  useSlashes: {
    type: Boolean,
    required: false,
    default: false,
  },
  logoImage: {
    type: String,
    required: false,
  },
  floatBgImage: {
    type: String,
    required: false,
  },
  personImage: {
    type: String,
    required: false,
  },
  label: {
    type: String,
    required: false,
  },
  isNew: {
    type: Boolean,
    required: false,
    default: false,
  },
  isHot: {
    type: Boolean,
    required: false,
    default: false,
  },
  variant: {
    type: String as PropType<
      "FLOATING_TAGS" | "TAGS_WITH_LOGO" | "LABEL_AND_PERSON"
    >,
    required: false,
    default: "FLOATING_TAGS",
  },
  isUseText: {
    type: Boolean,
    default: true,
  },
});
const {
  getAssetImage,
  onErrorDefaultImage,
  isHandleDefaultImageRender,
  isFloatBackgroundEntry,
} = commonHelper;
</script>
